///////////////////Software Control Header///////////////////////////////////
// TString.h - Library to support char string manipulation
//
// $LogThisFile$ \Projects\UtilCode\Include\TString.h
// 
// V01.03 14/03/2001 2129
//  ToInteger(int Location) added.
// 
// V01.02 29/10/2000 2308
//  RemoveLeft() and operator<<(float) added.
// 
// V01.01 26/10/2000 2155
//  Various changes to deallocate memory only if exceeding m_Limit.
//  Default to 1024 bytes.
// 
// V01.00 11/10/2000 2154
//  Initial revision.
// 
// This code is freely distributed to help the development of complex
// software in any field using C++. The author is not held responsible
// for any damage caused by the usage of the code.
// The author should be acknowledged for the use of this piece of code in
// commercial software.
//
// Bug reports and suggestions are welcomed to report to
//
//          tzzstan@hotmail.com
/////////////////////////////////////////////////////////////////////////////
#ifndef __TS_STRING__
#define __TS_STRING__

#include <iostream.h>
#include <iomanip.h>
#include <strstrea.h>
#include <ctype.h>

/////////////////////////////////////////////////////////////////////////////
// CTString - Class to hold and manipulate character string.
//
// TSTan   11 Oct 2000
/////////////////////////////////////////////////////////////////////////////
class CTString
{
   char *m_data;
   int m_Limit, m_Current;

public:
   CTString(char *string = "", int LimitingSize = 1024);
   CTString(const CTString &);
   ~CTString();

   ////////////////
   // Modifiers
   ////////////////

   CTString &operator=(CTString &);
   CTString &operator=(char *);
   void ToUpper();
   void SetAt(int Location, char Character);
   int RemoveAt(int Location);
   void RemoveLeft(int Characters);
   void InsertAt(int Location, char Character);
   void InsertAt(int Location, CTString &string);
   void SetLimit(int NewLimit) {m_Limit = NewLimit;}
	 int ToInteger(int Location = 0);

   ////////////////
   // Accessors
   ////////////////

   int Size();
   // Return char pointer to string.
   char *Data() {return m_data;}
   int GetChar(char Character, int FromLeftRight);
   bool operator==(CTString &);
   bool operator==(char *);
   bool operator<(CTString &);
   bool operator>(CTString &);
   bool operator>=(CTString &);
   bool operator<=(CTString &);
   CTString &operator+=(char *);
   CTString &operator+=(char);
   CTString &operator+=(CTString &);
   CTString &operator+=(int);
   CTString &operator+=(float);
   char operator[](int);

   friend ostream& operator<<(ostream &, CTString &);
};

#endif




