///////////////////Software Control Header///////////////////////////////////
// SingList.h - Demonstration of CSinglyList<>.
//
// $LogThisFile$ \Projects\UtilCode\TestCode\SingList\SingList.cpp
// 
// This code is freely distributed to help the development of complex
// software in any field using C++. The author is not held responsible
// for any damage caused by the usage of the code.
// The author should be acknowledged for the use of this piece of code in
// commercial software.
//
// Bug reports and suggestions are welcomed to report to
//
//          tzzstan@hotmail.com
/////////////////////////////////////////////////////////////////////////////
#include <stdio.h>

#include "TTree.h"
#include "BinTree.h"

bool Pets::operator<(Pets &theOther)
{
	return m_Name < theOther.m_Name;
}

bool Pets::operator>(Pets &theOther)
{
	return m_Name > theOther.m_Name;
}

void main()
{
   printf("Binary Tree demonstration program\n"
          "=================================\n");

   CTree<Pets> AllPets;
	bool SortOrder = true;
   while(1)
   {
      char buffer[80];
      printf("\n"
             "   1. Add pet - Dog\n"
             "   2. Add pet - Bird\n"
             "   3. Add pet - Fish\n"
             "   4. Remove all pets\n"
				 "   5. Change sort order\n"
             "   9. Quit\n"
             "Your choice: ");

      int choice;
      gets(buffer);
      sscanf(buffer, "%d", &choice);

      // Process the input
		if(choice == 4)	// Clear pet's list
         AllPets.RemoveAll();
      else if(choice == 9)	// Illegal input
         return;
      else if(choice >= 1 && choice <= 3)	// Add new pet
      {
         printf("Your pet's name: ");
         gets(buffer);
         Pets newPet(buffer, choice - 1);
         AllPets.Insert(newPet);
      }
		else if(choice == 5)
			SortOrder = !SortOrder;

      printf("\n"
             "Your have %d pets(sorted by name) including: \n",
             AllPets.Size());

      // Traverse the list and list out the pets
		CTreeLooper<Pets> Looper(AllPets, SortOrder);
		for(Looper.Reset(); Looper.IsValid(); Looper++)
      {
         Pets *tmpPtr = Looper.Current();
         printf("   %s named %s\n",
            tmpPtr->PetType(), tmpPtr->PetName());
      }
   }
}
